/****************************************************************************

         #####   #####  #     #       #  #####   #####    ###
        #     # #     # ##    #      #  #     # #     #    #
        #       #       # #   #     #   #       #          #
        #       #       #  #  #    #    #        #####     #
        #       #       #   # #   #     #             #    #
        #     # #     # #    ##  #      #     # #     #    #
         #####   #####  #     # #        #####   #####    ###

****************************************************************************/
/*
* @PROJECT  CCN/CSI
* @SYSTEM   APACHE
* @PACKAGE  HTTP2CSI
*
* @FILE     http2csi_upext.h
*
* @ABSTRACT
* Apache Http2csi module User & Provider EXTernal definitions
*
* This file contains:
* The external functions and Apache handlers definitions
*
* @INCLUDE

#ifndef _HTTP2CSI_UPEXT_H_
#define _HTTP2CSI_UPEXT_H_

static int Http2csiHandler(request_rec *);
static int Http2csiHeaderParser(request_rec *);

static const handler_rec handlers[] =
{
    {"http2csi-handler", Http2csiHandler},
    {NULL,NULL}
};

static void Http2csiChildInit(server_rec *s, pool *p);
static void Http2csiChildExit(server_rec *s, pool *p);

module MODULE_VAR_EXPORT Http2csiModule = {
    STANDARD_MODULE_STUFF,
    NULL,                              /* initializer */
    NULL,                              /* dir config creator */
    NULL,                              /* dir config merger */
    NULL,                              /* server config */
    NULL,                              /* merge server config */
    NULL,                              /* command table */
    handlers,                          /* handlers */
    NULL,                              /* filename translation */
    NULL,                              /* check_user_id */
    NULL,                              /* check auth */
    NULL,                              /* check access */
    NULL,                              /* type_checker */
    NULL,                              /* fixups */
    NULL,                              /* logger */
    Http2csiHeaderParser,              /* header parser */
    Http2csiChildInit,                 /* child_init */
    Http2csiChildExit,                 /* child_exit */
    NULL                               /* post read-request */
#ifdef EAPI
    ,NULL
    ,NULL
    ,NULL
    ,NULL
    ,NULL
#endif 
};

#endif /* _HTTP2CSI_UPEXT_H_ */
