/****************************************************************************

         #####   #####  #     #       #  #####   #####    ###
        #     # #     # ##    #      #  #     # #     #    #
        #       #       # #   #     #   #       #          #
        #       #       #  #  #    #    #        #####     #
        #       #       #   # #   #     #             #    #
        #     # #     # #    ##  #      #     # #     #    #
         #####   #####  #     # #        #####   #####    ###

****************************************************************************/
/*
* @PROJECT  CCN/CSI
* @SYSTEM   APACHE
* @PACKAGE  RAPMGMT
*
* @FILE     rapmgmt_prmes.h
*
* @ABSTRACT
* Apache RAP ManaGeMenT (RAPMGMT) handler PRivate MESsages definitions.
*
* This file contains:
* The TRACE and ERRORS messages definitions.
*
* @INCLUDE

#ifndef _RAPMGMT_PRMES_H
#define _RAPMGMT_PRMES_H

#include "evr_upmac.h"


#define RAPMGMT_ERROR_NO_COOKIE       1L
#define RAPMGMT_ERROR_NO_TICKET       2L
#define RAPMGMT_ERROR_NO_PROFILE      3L
#define RAPMGMT_ERROR_NO_SITE         4L
#define RAPMGMT_ERROR_NO_REQUEST      5L
#define RAPMGMT_ERROR_NO_RAP          6L
#define RAPMGMT_ERROR_BAD_REQ         7L
#define RAPMGMT_ERROR_PIPE            8L 
#define RAPMGMT_ERROR_FORK            9L
#define RAPMGMT_ERROR_DUP2           10L
#define RAPMGMT_ERROR_EXEC           11L
#define RAPMGMT_ERROR_FDOPEN         12L
#define RAPMGMT_ERROR_WRITE          13L
#define RAPMGMT_ERROR_WAITPID        14L
#define RAPMGMT_ERROR_USAGE          15L
#define RAPMGMT_ERROR_CDX            16L
#define RAPMGMT_ERROR_OS             17L
#define RAPMGMT_ERROR_RAP_NOT_FOUND  18L
#define RAPMGMT_ERROR_RAP_MANAGED    19L
#define RAPMGMT_ERROR_TUXEDO         20L
#define RAPMGMT_ERROR_READ	     21L
#define RAPMGMT_ERROR_CHILD          22L
#define RAPMGMT_ERROR_SIGNAL         23L
#define RAPMGMT_ERROR_PIPE_SIGNAL    24L
#define RAPMGMT_ERROR_CHILD_SIGNALED 25L
#define RAPMGMT_ERROR_CHILD_STOPPED  26L

CSICHAR *RAPMGMT_ERROR_MSGS[] = 
{
/* 01 */ "No cookie defined !"
/* 02 */,"No ticket defined !"
/* 03 */,"No profile in ticket !"
/* 04 */,"No site in ticket !"
/* 05 */,"The request argument is missing !"
/* 06 */,"The site and/or gateway and/or rap name is missing !"
/* 07 */,"Bad request : %s !"
/* 08 */,"Internal error encountered while executing pipe() : %d"
/* 09 */,"Internal error encountered while executing fork() : %d"
/* 10 */,"Internal error encountered while executing dup2() : %d"
/* 11 */,"Internal error encountered while executing exec() : %d"
/* 12 */,"Internal error encountered while executing fdopen() : %d"
/* 13 */,"Internal error encountered while executing write() : %d"
/* 14 */,"Internal error encountered while executing waitpid() : %d"
/* 15 */,"Usage : %s action (%s|%s|%s|%s) "
         "user_site "       
         "profile_1 [[profile_2] ... [profile_n]] "
         "[site for action = (%s|%s|%s)] "   
         "[gateway for action = (%s|%s|%s)] "
         "[rap for action = (%s|%s)]"
/* 16 */,"CDX error in %s, retrun code : %ld, reason code : %ld"
/* 17 */,"OS error in %s, retrun code : %ld, reason code : %ld"
/* 18 */,"The rap %s running on the gateway %s and site %s cannot be found !"
/* 19 */,"The rap %s defined on the gateway %s and site %s cannot be managed by this user !"
/* 20 */,"TUXEDO error %d in %s function !"
/* 21 */,"Internal error encountered while executing read() : %d"
/* 22 */,"Child %ld terminated with status %d"
/* 23 */,"Internal error encountered while executing signal() : %d"
/* 24 */,"Pipe signal caught"
/* 25 */,"Child %ld terminated with signal %d"
/* 26 */,"Child %ld stopped with signal %d"
};


#endif /* _RAPMGMT_PRMES_H */
