/****************************************************************************

         #####   #####  #     #       #  #####   #####    ###
        #     # #     # ##    #      #  #     # #     #    #
        #       #       # #   #     #   #       #          #
        #       #       #  #  #    #    #        #####     #
        #       #       #   # #   #     #             #    #
        #     # #     # #    ##  #      #     # #     #    #
         #####   #####  #     # #        #####   #####    ###

****************************************************************************/
/*
* @PROJECT  CCN/CSI
* @SYSTEM   APACHE
* @PACKAGE  GEN_PROXY
*
* @FILE     gen_proxy_print.c
*
* @ABSTRACT
* This module is executed by the process httpd if the
* directive CCNProxyRemote is set to On in the file httpd.conf 
*
* This file contains:
*
* @INCLUDE

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include <regex.h>

#include "gen_proxy_upcon.h"
#include "gen_proxy_prtyp.h"
#include "gen_proxy_prext.h"


CSILONG buildProxyPattern1(char* szPattern, int nb_subexpr,regmatch_t *pat_match,PROXYHEADER* szProxyInfo)
{
  int i = 0;
  int j = 0;
  int start = 0;
  int end = 0;
  char sub_pattern[MAX_SUB_STRING][48];

  for (i = 1 ; i <= nb_subexpr ; i++)
  {
    memset(sub_pattern[i-1],'\0',sizeof(sub_pattern[i-1]));
    strncpy(sub_pattern[i-1], &szPattern[pat_match[i].rm_so], pat_match[i].rm_eo - pat_match[i].rm_so);
  }
  start = atoi(sub_pattern[1]);
  end = atoi(sub_pattern[2]);
  for (j = start ; j <= end ; j++)
  {
    printf("ProxyRemote %s://%s.%s.%s:%s%d http://%s.%s.%s:%s\n",
                     (CSITRUE == szProxyInfo->isHttps) ? "https" : "http",
                     szProxyInfo->szWebHostPart1,
                     szProxyInfo->szWebSite,
                     szProxyInfo->szWebDomain,
                     sub_pattern[0],
                     j,
                     szProxyInfo->szProxyRemote,
                     szProxyInfo->szWebSite,
                     szProxyInfo->szWebDomain,
                     TARGET_PORT_NUMBER);
  }
  return 1;
}

CSILONG buildProxyPattern2(char* szPattern, int nb_subexpr,regmatch_t *pat_match,PROXYHEADER* szProxyInfo)
{
  int i = 0;
  int j = 0;
  int k = 0;
  int start = 0;
  int end = 0;
  char sub_pattern[MAX_SUB_STRING][48];

  for (i = 1 ; i <= nb_subexpr ; i++)
  {
    memset(sub_pattern[i-1],'\0',sizeof(sub_pattern[i-1]));
    strncpy(sub_pattern[i-1], &szPattern[pat_match[i].rm_so], pat_match[i].rm_eo - pat_match[i].rm_so);
  }

  start = atoi(sub_pattern[1]);
  end = atoi(sub_pattern[2]);
  for (j = start ; j <= end ; j++)
  {
    for (k = start ; k <= end ; k++)
    {
      printf("ProxyRemote %s://%s.%s.%s:%s%d%d http://%s.%s.%s:%s\n",
                       (CSITRUE == szProxyInfo->isHttps) ? "https" : "http",
                       szProxyInfo->szWebHostPart1,
                       szProxyInfo->szWebSite,
                       szProxyInfo->szWebDomain,
                       sub_pattern[0],
                       j,
                       k,
                       szProxyInfo->szProxyRemote,
                       szProxyInfo->szWebSite,
                       szProxyInfo->szWebDomain,
                       TARGET_PORT_NUMBER);

    }
  }
  return 1;
}

CSILONG buildProxyPattern3(char* szPattern, int nb_subexpr,regmatch_t *pat_match,PROXYHEADER* szProxyInfo)
{
  int i = 0;
  int j = 0;
  int k = 0;
  int start1 = 0;
  int end1 = 0;
  int start2 = 0;
  int end2 = 0;
  char sub_pattern[MAX_SUB_STRING][48];

  for (i = 1 ; i <= nb_subexpr ; i++)
  {
    memset(sub_pattern[i-1],'\0',sizeof(sub_pattern[i-1]));
    strncpy(sub_pattern[i-1], &szPattern[pat_match[i].rm_so], pat_match[i].rm_eo - pat_match[i].rm_so);
  }

  start1 = atoi(sub_pattern[1]);
  end1 = atoi(sub_pattern[2]);
  start2 = atoi(sub_pattern[3]);
  end2 = atoi(sub_pattern[4]);

  for (j = start1 ; j <= end1 ; j++)
  {
    for (k = start2 ; k <= end2 ; k++)
    {
      printf("ProxyRemote %s://%s.%s.%s:%s%d%d http://%s.%s.%s:%s\n",
                       (CSITRUE == szProxyInfo->isHttps) ? "https" : "http",
                       szProxyInfo->szWebHostPart1,
                       szProxyInfo->szWebSite,
                       szProxyInfo->szWebDomain,
                       sub_pattern[0],
                       j,
                       k,
                       szProxyInfo->szProxyRemote,
                       szProxyInfo->szWebSite,
                       szProxyInfo->szWebDomain,
                       TARGET_PORT_NUMBER);

    }
  }
  return 1;
}

CSILONG buildProxyPattern4(char* szPattern, int nb_subexpr,regmatch_t *pat_match,PROXYHEADER* szProxyInfo)
{
  int i = 0;
  char sub_pattern[MAX_SUB_STRING][48];

  for (i = 1 ; i <= nb_subexpr ; i++)
  {
    memset(sub_pattern[i-1],'\0',sizeof(sub_pattern[i-1]));
    strncpy(sub_pattern[i-1], &szPattern[pat_match[i].rm_so], pat_match[i].rm_eo - pat_match[i].rm_so);
  }

  printf("ProxyRemote %s://%s.%s.%s:%s http://%s.%s.%s:%s\n",
                      (CSITRUE == szProxyInfo->isHttps) ? "https" : "http",
                      szProxyInfo->szWebHostPart1,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      sub_pattern[0],
                      szProxyInfo->szProxyRemote,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      TARGET_PORT_NUMBER);
  return 1;
}

CSILONG buildProxyPattern5(char* szPattern, int nb_subexpr,regmatch_t *pat_match,PROXYHEADER* szProxyInfo)
{
  int i = 0;
  char sub_pattern[MAX_SUB_STRING][48];

  for (i = 1 ; i <= nb_subexpr ; i++)
  {
    memset(sub_pattern[i-1],'\0',sizeof(sub_pattern[i-1]));
    strncpy(sub_pattern[i-1], &szPattern[pat_match[i].rm_so], pat_match[i].rm_eo - pat_match[i].rm_so);
  }

  printf("ProxyRemote %s://%s.%s.%s:80 http://%s.%s.%s:%s\n",
                      (CSITRUE == szProxyInfo->isHttps) ? "https" : "http",
                      szProxyInfo->szWebHostPart1,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      szProxyInfo->szProxyRemote,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      TARGET_PORT_NUMBER);

  printf("ProxyRemote %s://%s.%s.%s:8080 http://%s.%s.%s:%s\n",
                      (CSITRUE == szProxyInfo->isHttps) ? "https" : "http",
                      szProxyInfo->szWebHostPart1,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      szProxyInfo->szProxyRemote,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      TARGET_PORT_NUMBER);
  return 1;
}

CSILONG buildProxyPattern6(char* szPattern, int nb_subexpr,regmatch_t *pat_match,PROXYHEADER* szProxyInfo)
{
  int i = 0;
  char sub_pattern[MAX_SUB_STRING][48];

  for (i = 1 ; i <= nb_subexpr ; i++)
  {
    memset(sub_pattern[i-1],'\0',sizeof(sub_pattern[i-1]));
    strncpy(sub_pattern[i-1], &szPattern[pat_match[i].rm_so], pat_match[i].rm_eo - pat_match[i].rm_so);
  }
  printf("ProxyRemote %s://%s.%s.%s http://%s.%s.%s:%s\n",
                      (CSITRUE == szProxyInfo->isHttps) ? "https" : "http",
                      szProxyInfo->szWebHostPart1,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      szProxyInfo->szProxyRemote,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      TARGET_PORT_NUMBER);

  printf("ProxyRemote %s://%s.%s.%s:%s http://%s.%s.%s:%s\n",
                      (CSITRUE == szProxyInfo->isHttps) ? "https" : "http",
                      szProxyInfo->szWebHostPart1,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
		      sub_pattern[0],
                      szProxyInfo->szProxyRemote,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      TARGET_PORT_NUMBER);

  return 1;
}

CSILONG buildProxyPattern7(char* szPattern, int nb_subexpr,regmatch_t *pat_match,PROXYHEADER* szProxyInfo)
{
  return (buildProxyPattern6(szPattern,nb_subexpr,pat_match,szProxyInfo));
}

CSILONG buildProxyPattern8(char* szPattern, int nb_subexpr,regmatch_t *pat_match,PROXYHEADER* szProxyInfo)
{
  printf("ProxyRemote %s://%s.%s.%s http://%s.%s.%s:%s\n",
                      (CSITRUE == szProxyInfo->isHttps) ? "https" : "http",
                      szProxyInfo->szWebHostPart1,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      szProxyInfo->szProxyRemote,
                      szProxyInfo->szWebSite,
                      szProxyInfo->szWebDomain,
                      TARGET_PORT_NUMBER);

  return 1;
}
